class Coordinate{
  float x, y, z;
  color c;
  
  Coordinate(float x, float y, float z, color c) {
    this.x = x;
    this.y = y;
    this.z = z;
    this.c = c;
  }

}

class Word implements Comparable<Word>{

  int year;
  String word;
  float count;
  float x,y,z;
  color c;
  
  Word(int year, String word, float count, float x, float y, float z, color c) {
    this.year = year;
    this.word = word;
    this.count = count;
    this.x = x;
    this.y = y;
    this.z = z;
    this.c = c;
  }
  
  public int compareTo(Word w) {
    
    if(this.count == w.count) {
      return 0;
    } else if (this.count > w.count) {
      return 1;
    } else {
      return -1;
    }
  }
  
  public void render(Set<String> selected, int renderMode) {
    
    int alpha = 255;
    if(renderMode == 1){
      alpha = 100;
    }
    
    noStroke();
    translate(this.x, this.y, this.z);
    if (selected.size() > 0) {
      if (selected.contains(this.word)) {
        color c = this.c;
        int r = (c >> 16) & 0xFF;
        int g = (c >> 8) & 0xFF;
        int b = c & 0xFF;
        r = constrain(r * 3, 0, 255);
        g = constrain(g * 3, 0, 255);
        b = constrain(b * 3, 0, 255);
        fill(color(r, g, b), alpha);
      } else {
        fill(this.c, alpha);
      }
    } else {
      color c = this.c;
      int r = (c >> 16) & 0xFF;
      int g = (c >> 8) & 0xFF;
      int b = c & 0xFF;
      r = constrain(r * 2, 0, 255);
      g = constrain(g * 2, 0, 255);
      b = constrain(b * 2, 0, 255);
      fill(color(r, g, b), alpha);
    }
    
    if(renderMode == 0) {
      textAlign(CENTER, CENTER);
      textSize(this.count);
      textMode(MODEL);
      rotateY(-HALF_PI);
      text(this.word, 0, 0);
    } else {
      sphereDetail(5);
      sphere(this.count);
    }
  }
}
